package example;

import pt.ist.fenixframework.Atomic;
import pt.ist.fenixframework.DomainRoot;
import pt.ist.fenixframework.FenixFramework;

public class HelloWorld {

    // FenixFramework will try automatic initialization when first accessed
    public static void main(String [] args) {
        try {
            addNewPeople(args);
            greetAll();
        } finally {
            // ensure an orderly shutdown
            FenixFramework.shutdown();
        }
    }

    @Atomic
    private static void addNewPeople(String[] args) {
        DomainRoot root = FenixFramework.getDomainRoot();
        for (String name : args) {
            new Person(name, root);
        }
    }

    @Atomic
    private static void greetAll() {
        DomainRoot root = FenixFramework.getDomainRoot();
        for (Person p : root.getPeople()) {
            p.sayHello();
        }
    }
}
